! this is a program to estimate variances in a MM including
! mean, one fixed effect (gender) and SNP's
! THIS IS THE ONLY MODEL BY NOW!!
! All SNP have the same variance
! Estimation is by Gibbs Sampling with iteration on data with or without variance component estilation
! or BLUP by Gauss Seidel
! using a "solving by effects" technique (e.g. Notes by Misztal, Janss & DeJong 1999,
! Misztal & Gianola 1987)
! includes one animal effect which assumes ONE RECORD PER ANIMAL
! A-1 is stocked in dense
! predict is read as option and produces a file 'predictions' with predicted phenotypes (with sol taken from the
! solutions file read in the par file)

! Andres Legarra
! 17/1/07
! saving for continuation implemented
! Uses:
!     -a parameter file (example: together.animal.par) This par file
!      includes an option to solve the system by Gauss Seidel (BLUP) or MCMC  (MCMCBLUP)
!      with known variance components, or to estimate these and
!      the solutions (VCE). Also options for MCMC and convergence
!     -pedigree and data files detailed in the parameter file
!     -a file continuation.txt to continue the MCMC if needed
!     -the continuation of the var samples is in varfile_cont
! Produces:
!     -a file with samples of the variance components, name detaild in the par file (if option VCE)
!     -a file with solutions
! TODO: 
!     -X and Z are redundanT!!
!     -model flexibility
! last change 8/6/07

! gs_sparse: I try to put more model flexibility. How:
! variable number of effects ?
! sparse storage of A-1 largely overpass gs_aonly
! should I stock X in sparse as well??


! this is a modification to run a mixture model, as proposed by JME
! a_i ~ (1-p)dirac(0) + p N(0,vara) for the genomic effects only!
! by classical MCMC for mixture models
! (stochastic search variable selection) 
! There is no problem of label switching here.
! ML should be attainable without much effort on the basis of BLUP solutions
! I use variable i_inmodel to say if a given SNP is in or out. This is later used for estimation of p 
! serious bug corrected 7/5/07

! 1/8/07
! This is a copy from gs_sparse_mixt, which is able to 
!   -select given rows from the data file
!   -include one permanent effect "cage" (not difficult to be extended)
!   -disable mixture approach if needed
!   -model flexibility (
! SNP have to be kept as the last column in data file for ease of reading
! ToDo:
!   -handle missing values (skipping them or doing data augmentation?)
!   verificar los resultados
! 4/3/08
! I have added writing of EBVs
! Doc
! Corrected inconsistency in predict and avinmodel
! Corrected bug in computation of length(in_data)
! 29/5/08 Corrected bug in computation of length(in_data)
! 10/08/09 Missing covariates for snp's allowed (with effect=0)
!          Corrected too small rec options
!          Introducing heterogeneous variances



program gs_cage
use kinds
use random
use stat
use sparsem
use denseop
use boots

! we parameterize the model in terms of an effect
!   +1/2a for SNP 1
!   -1/2a for SNP 2
!   +d for SNP combination 12
! therefore: 11 -> a 12 -> d 22 -> -a


implicit none
! parameters of the model
integer:: neff,&
          nSNP
		    
integer,allocatable:: nlev(:),offset(:),pos_eff(:),type_eff(:)
character(20):: type_this_eff,type_eff_char(7)=(/'cross        ',&
                                                 'cov          ',&
						 'add_animal   ',&
						 'perm_diagonal',&
						 'add_SNP      ',&
						 'dom_SNP      ',&
						 'ind_SNP      '/)
integer,parameter:: cross=1,cov=2,add_animal=3,perm_diagonal=4,add_SNP=5,dom_SNP=6,ind_SNP=7

logical,allocatable:: inmodel(:),&
                      i_inmodel(:)
integer :: neq,efaSNP,efdSNP,efanim,efp,traitcol,het_var_col,maxrec=10000

type design_matrix 
  ! this uses TR 15581 standard, available in most compilers in particular gfortran and g95
  real(r8),allocatable:: cov(:) !value of the covariable
  integer,allocatable:: eq(:) !number of equation
  integer,allocatable:: rec(:) !number of record
  integer,allocatable:: ia_eq(:,:) !address of the first and last elements in X for the i-th eq
end type design_matrix
  
real(r8),allocatable:: in_data(:)		    
type(design_matrix) ::X ! for "sparse" effects
real(r8),allocatable::y(:),ywiggle(:),&
		      xpx(:),& ! diagonal of LHS
		      Z(:,:),& !add_SNP effects 
		      W(:,:),& !dom_SNP effects 
		      sol(:),& !vector of solutions
		      sumsol(:),& !vector of accumumated solutions
		      diagAinv(:),& !diag of A-inverse
		      avinmodel(:),& ! vector with p of a given effect being accounted for in the model
		                     ! in fact this is done only for SNP effects
		      sumxpx(:),& !vector with product X 1 filtered with i_inmodel
		      D(:),& !diagonal vector with inverses of variances (A-1, D-1, etc) for each effect
		      R(:) ! diagonal matrix with heterogeneous residual variances
		      
		      
type(sparse_hashm):: Ainv_hash		      
type(sparse_ija):: Ainv_ija
real(r8):: vara,vard,vare,varg,varp
real(r8):: vara_ap,vard_ap,vare_ap,varg_ap,varp_ap ! apriori
real(r8):: dfvara,dfvare,dfvard,dfvarg,dfvarp !degrees of freedom for the a priori distribution
real(r8):: val,lhs,rhs,eps,conv_crit=1e-10,edc
!read-in variables
character(len=150000):: genome !150000 is an upper limit!
integer,allocatable:: SNPoneanim(:,:),& !(nSNP,2) !SNP combination for one animal
                      id(:) !id for the n-th record

character(200):: parfile,datafile,method,varfile,solfile,pedfile

integer:: i,j,k,l,io,ndata,pos,iterout,iterin,pos1,pos2,iter,nanim,beginouter,record_id
integer:: niter,burnin,thin,correction
logical:: simulation,MCMCBLUP,GaussSeidel,VCE,continuation,predict,use_mixture

! new variables for the mixture model
real(r8):: pa(2),aprioria(2),sumpa(2) !mixture parameters for the a dditive SNP effect
real(r8):: pd(2),apriorid(2),sumpd(2) !mixture parameters for the a dditive SNP effect
real(r8):: like1,like2,aposteriori(2)
integer:: includeda,includedd

integer:: saving=1000

print *, ('what parameter file?')
read(*,*)parfile
open(unit=10,file=parfile,status='old')
efaSNP=0
efdSNP=0 
efanim=0
efp=0

call read_par_file()

!call get_clock_seeds()

open(unit=1,file=datafile,status='old',recl=150000)
!open(unit=2,file='yX.txt',status='replace')
if(VCE) then
  if (continuation) then
    open(unit=3,file=trim(varfile)//'_cont',status='replace') !create new file
  else
    open(unit=3,file=varfile,status='replace')
  endif
endif
open(unit=14,file=trim(parfile)//'_EBVs',status='replace')  


!prediction  
if (predict) then
  open(unit=4,file=solfile,status='old')
  open(unit=12,file='predictions',status='replace')  
endif  


! get size
ndata=0
do
  read(1,*,iostat=io)in_data
  do i=1,neff
    if( (type_eff(i)==cross).or.&
!        (type_eff(i)==cov).or.& covariates are assumed 1 level (i.e. no nesting)
	(type_eff(i)==perm_diagonal)  ) then
	if (nlev(i)<nint(in_data(pos_eff(i)))) then
	  print *,'BEWARE'
	  print *,'number of levels for effect ',i,'type ',type_eff_char(type_eff(i)), &
	          'changed from ',nlev(i),'to',nint(in_data(pos_eff(i)))
          nlev(i)=max(nlev(i),nint(in_data(pos_eff(i))))
	endif
    else if (type_eff(i)==cov) then
      nlev(i)=1
    endif	
  enddo
  if(io/=0) exit
  ndata=ndata+1
enddo
rewind(1)

nanim=0
if(efanim/=0) then
  open(unit=7,file=pedfile,status='old')
  nanim=0
  do
    read(7,*,iostat=io)
    if(io/=0) exit
    nanim=nanim+1
  enddo
  rewind(7)
    nlev(efanim)=nanim
endif    
where (type_eff==add_SNP)
  nlev=nSNP
end where
where (type_eff==dom_SNP)
  nlev=nSNP
end where


! put code to guess number of levels for fixed effects

neq=sum(nlev)

call print_info()

offset(1)=0
do i=2,neff !get the address of the last level of the i-1th effect
  offset(i)=sum(nlev(1:i-1))
enddo  
print *,offset

!set up of X
allocate(X%cov(maxrec))
allocate(X%rec(maxrec))
allocate(X%eq(maxrec))
allocate(X%ia_eq(neq,2))
X%cov=0
X%rec=0
X%eq=0
X%ia_eq=0


allocate( y(ndata),&
          id(ndata),&
          ywiggle(ndata),&
	  xpx(neq),&
	  D(neq),&
	  i_inmodel(neq),&
	  diagAinv(nanim),&
	  SNPoneanim(nSNP,2),&
	  sumsol(neq),&
	  sumxpx(neq),&
	  avinmodel(neq),&
	  sol(neq) ) 
	  
X%cov=0d0; X%rec=0; X%eq=0
y=0d0; ywiggle=0d0
sol=0d0
diagAinv=0d0
xpx=0d0
if(efanim/=0) then 
  call init(Ainv_hash)
  call init(Ainv_ija)
  call zerom(Ainv_hash,nanim)
  call zerom(Ainv_ija,nanim)
endif
if(efaSNP/=0) then
  allocate(Z(ndata,nSNP))
  Z=0d0
endif
if(efdSNP/=0) then
  allocate(W(ndata,nSNP))
  Z=0d0
endif
sumsol=0d0
beginouter=1
avinmodel=0d0 
sumpa=0d0
sumpd=0d0

if(efanim/=0) then
  ! set up A inverse
  call add_g_add(3)
  print *,'a-1'
  close (7)
endif
!set up design matrix for f.e. and SNPs

pos=0
createX: do i=1,ndata
  if((efaSNP/=0).or.(efdSNP/=0)) then
    read(1,*,iostat=io)in_data,genome(1:nSNP*2)
  else
    read(1,*,iostat=io)in_data
  endif
  if(io/=0) exit
  if(mod(i,100)==0) print *,i,'-th record'
  y(i)=in_data(traitcol)
!  if(efanim/=0) then
!    id(i)=in_data(pos_eff(efanim))
!  else
    id(i)=in_data(record_id)
!  endif
  do j=1,neff
    val=0d0
    !regular effects
    if(type_eff(j)==cov) then
      pos=pos+1
      if(inmodel(j)) val=in_data(pos_eff(j))
      pos1=add(j,1)      
      call add_X(cov=val,rec=i,eq=pos1,pos=pos)
    elseif( (type_eff(j)==cross).or. & 
            (type_eff(j)==add_animal).or. &
            (type_eff(j)==perm_diagonal) ) then
      pos=pos+1
      if(inmodel(j)) val=1d0
      pos1=add(j,nint(in_data(pos_eff(j))))
      call add_X(cov=val,rec=i,eq=pos1,pos=pos)
!      print *,'read',in_data(pos_eff(j)),'effect',j
!      print *,val,i,pos1,pos
!      pause
    ! SNP effects  
    elseif( (type_eff(j)==add_SNP).or. & 
            (type_eff(j)==dom_SNP) ) then
      SNPoneanim=splittoint(genome(1:nSNP*2),nSNP)
      do k=1,nSNP
        if (type_eff(j)==add_SNP)then
	  ! create 'a' effect
	  val=0d0
	  do l=1,2
	    select case (SNPoneanim(k,l)) 
              case(1) 
        	val=val+0.5d0
              case(2)
		val=val-0.5d0
              case default
	        val=val-200d0 ! this allows to identify missing values
		!print *,'neither 1 nor 2 --> assumed missing',id(i),'animal',k,'SNP'
            end select
	    if(.not.inmodel(j)) val=0d0
	  enddo  
	  pos1=k
	  Z(i,pos1)=val
	endif
	if (type_eff(j)==dom_SNP) then
	! create d effect if both SNPs differ
          if (SNPoneanim(k,1)/=SNPoneanim(k,2)) then
	    val=1d0
          else
	    val=0d0
          endif  
          if(.not.inmodel(j)) val=0d0
          pos1=k
          W(i,pos1)=val
	endif
      enddo
    endif
  enddo
enddo  createX
! missing values should be fixed to the average value of its column
if(efaSNP/=0) then
  do i = 1,nsnp
    val=sum(Z(:,i), mask=(Z(:,i) > -100d0) )/count(Z(:,i) > -100d0) !mean of non-missing values
    where (Z(:,i) < -100d0)
      Z(:,i)=val
    end where
  enddo
endif      
if(nsnp<10) call printmat(Z)

call increase_X(pos) !trim X
call sort_X() !sort equation-wise
call index_X() !set up index to 1st eq term
close(1)


! model stuff
call setup_inmodel() !prepare logical vector defining if eq i is in the model or not.


! call simulation
if (simulation) then
  print *,'not implemented yet'
  call simulate()
  stop
endif  


! prediction
if(predict) then
  !read solutions
  read(4,*) !skip title
  do i=1,neq
    read(4,*)pos1,pos2,sol(i),avinmodel(i)
  enddo  
  call predict_y(nofixedeffects=.true.) !take out fixed effects

  !compute predicted phenotypes minus fixed effects (supposedly well estimated)
!  ywiggle=matmul(X(:,4:neq),sol(4:neq))
  ! correct y 
!  y=y-matmul(X(:,1:3),sol(1:3))
  !write it out
  write(12,*) 'id true prediction'
  do i=1,ndata
    write(12,*)id(i),y(i),ywiggle(i)
  enddo  
  print *,'predictions written'
  !compute correlation  
  print *,'correlation ',compute_corr(y,ywiggle),'vary vary^', compute_var(y),compute_var(ywiggle)

  call compute_EBV()
  print *,'--prediction finished, end of program!--'
  stop !!end of program here
  
endif  

! begin of computations
ywiggle=y
 
!diag of LHS for sparse effects 
do i=1,neq
  pos1=X%ia_eq(i,1)
  pos2=X%ia_eq(i,2)
  if(pos1==0)cycle !for example for animal effects w/o record
  xpx(i)=dot_product(X%cov(X%ia_eq(i,1):X%ia_eq(i,2)),X%cov(X%ia_eq(i,1):X%ia_eq(i,2)))
  ! wrong?
enddo


! id for SNP effects
if(efaSNP/=0) then
  pos1=add(efaSNP,1)-1
  do i=1,nlev(efaSNP)
    xpx(pos1+i)=dot_product(Z(:,i),Z(:,i))
  enddo
endif
if(efdSNP/=0) then
  pos1=add(efdSNP,1)-1
  do i=1,nlev(efdSNP)
    xpx(pos1+i)=dot_product(W(:,i),W(:,i))
  enddo
endif
! write [y : X ]' for checking (disabled)

close(2)
if((.not.continuation).and.(VCE))write(3,*)'vara vard varg varp vare pa_1 pd_1'

!gibbs sampler
if(continuation) then
  if(VCE.or.MCMCBLUP) call restart_iter()
  beginouter=iter/thin
  call compute_residuals()
  print *,'correction'
endif  


    ! set up inverses of the variance for random effects
D=0d0
if(efaSNP/=0) D(add(efaSNP,1):add(efaSNP,nlev(efaSNP)))=1d0/vara
if(efdSNP/=0) D(add(efdSNP,1):add(efdSNP,nlev(efdSNP)))=1d0/vard
if(efp/=0)    D(add(efp,1):add(efp,nlev(efp)))=1d0/varp


 
outer: do iterout=beginouter,niter/thin
  inner: do iterin=1,thin
    eps=0d0
    iter=(iterout-1)*thin+iterin
    
    ! set up D only if in model, otherwise 0
    ! set up inverses of the variance for random effects
    if(efaSNP/=0) D(add(efaSNP,1):add(efaSNP,nlev(efaSNP)))=1d0/vara
    if(efdSNP/=0) D(add(efdSNP,1):add(efdSNP,nlev(efdSNP)))=1d0/vard
    if(efp/=0)    D(add(efp,1):add(efp,nlev(efp)))=1d0/varp
  
    if  (mod(iter,correction)==0) then
      call compute_residuals()
      print *,'correction'
    endif
    
    ! call predict_missing_y() ! in fact I predict missing residuals, is it useful?
                               ! not implemented yet
    
    loopeffects: do j=1,neff ! all effects 
      
      if(.not.inmodel(j)) then 
!        print *,'skipping ef',j
	cycle loopeffects !skip effects out of model
      endif
      do i=add(j,1),add(j,nlev(j)) 
        !form lhs
	lhs=xpx(i)/vare+D(i)
        if(type_eff(j)==add_SNP) then 
            rhs=dot_product(Z(:,i-offset(j)),ywiggle)/vare+xpx(i)/vare*sol(i)
        elseif(type_eff(j)==dom_SNP) then
            rhs=dot_product(W(:,i-offset(j)),ywiggle)/vare+xpx(i)/vare*sol(i)
        else 
            !sampling for sparse effects
            ! form rhs with y corrected by (iter-1) computation of b(i)
	    rhs=0d0
	    do k=X%ia_eq(i,1),X%ia_eq(i,2) !through all records affected by 'i'
	      if(k==0) exit
	      rhs=rhs+X%cov(k)*ywiggle( X%rec(k) )
	    enddo
	    rhs=rhs/vare+xpx(i)/vare*sol(i)
            if(type_eff(j)==add_animal) then
              pos1=add(efanim,1)
	      lhs=lhs+diagAinv(i-offset(j))/varg
              pos2=add(efanim,nlev(efanim))
              rhs=update_gs_one_col(i-offset(j),Ainv_ija,varg,sol(pos1:pos2),rhs)
            endif
        endif
	! sample solution from its conditional
	if(lhs==0) cycle
	if(.not.GaussSeidel) then
          val=normal(rhs/lhs,1d0/lhs)
	  ! or do Gauss Seidel
	else
          val=rhs/lhs
	endif
	
        if(use_mixture) then
	! note that this only works for MCMC
          if ((type_eff(j)==add_SNP)) then
	   ! compute loglikelihood for state 1 (i -> in model)
	     like1=log_like_normal( ywiggle - Z(:,i-offset(j))*(val-sol(i))  ,vare )
	   ! compute loglikelihood for state 2 (i -> not in model)
	     like2=log_like_normal( ywiggle + Z(:,i-offset(j))*sol(i),vare)
           ! I need to use loglikelihoods to avoid overflows
	    aposteriori=(/like1,like2/)+log(pa) 
          elseif ((type_eff(j)==dom_SNP)) then
	   ! compute loglikelihood for state 1 (i -> in model)
	     like1=log_like_normal( ywiggle - W(:,i-offset(j))*(val-sol(i))  ,vare )
	   ! compute loglikelihood for state 2 (i -> not in model)
	     like2=log_like_normal( ywiggle + W(:,i-offset(j))*sol(i),vare)
           ! I need to use loglikelihoods to avoid overflows
	    aposteriori=(/like1,like2/)+log(pd) 
	  endif
          if ((type_eff(j)==add_SNP).or.&
	      (type_eff(j)==dom_SNP)) then
	    ! a posteriori is in the log scale
	    ! so I use a function to pass it to 0-1
	    i_inmodel(i)=importance((/.true.,.false./),log2p(aposteriori))
	    if(.not.i_inmodel(i))then 
	      val=0d0
	    endif
	  endif
        endif

	!convergence criteria for Gauss Seidel
        eps=eps+(val-sol(i))**2
	! correct y for that effect
        if(type_eff(j)==add_SNP) then 
          ywiggle=ywiggle - Z(:,i-offset(j))*(val-sol(i))  
        elseif(type_eff(j)==dom_SNP) then
          ywiggle=ywiggle - W(:,i-offset(j))*(val-sol(i))  
        else 
	  do k=X%ia_eq(i,1),X%ia_eq(i,2) !through all records affected by 'i'
	    if(k==0) exit !unknowns not in data
	    ywiggle(X%rec(k))=ywiggle(X%rec(k)) - X%cov(k)*(val-sol(i))
	  enddo
        endif
	!update sol
	sol(i)=val
      enddo
    enddo loopeffects
         
    if(efaSNP/=0) includeda=count(i_inmodel(add(efaSNP,1):add(efaSNP,nlev(efaSNP))))
    if(efdSNP/=0) includedd=count(i_inmodel(add(efdSNP,1):add(efdSNP,nlev(efdSNP))))
            
    if ((eps<conv_crit).and.(GaussSeidel)) then
      avinmodel=1d0
      print *,iter,'eps',eps
      exit outer
    endif
    if(.not.GaussSeidel) then
      if(iter>burnin)then
       sumsol=sumsol+sol 
       where(i_inmodel) avinmodel=avinmodel+1d0    
       sumpa=sumpa+pa
       sumpd=sumpd+pd
      endif
    endif
    
    if(VCE) then
      ! sample vars
      ! form sums of squares and expectations (Rao-Blackwell estimates)
      if(efaSNP/=0) then
        if(dfvara<1000) then
          pos1=add(efaSNP,1)
          pos2=add(efaSNP,nlev(efaSNP))
          vara=(sum(sol(pos1:pos2)**2) + vara_ap*dfvara)/ &
          (dble(includeda) + dfvara) 
          vara=chin(vara,includeda+dfvara)
	endif
      endif

      if(efdSNP/=0) then
        if(dfvard<1000) then
          vard=(sum(sol(add(efdSNP,1):add(efdSNP,nlev(efdSNP)))**2) + vard_ap*dfvard)/ &
          (dble(includedd) + dfvard)
          vard=chin(vard,dble(includedd)+dfvard)
        endif
      endif
      if(efanim/=0) then
        if(dfvarg<1000) then
          pos1=add(efanim,1)
          pos2=add(efanim,nlev(efanim))
          varg=(quadrf(sol(pos1:pos2),Ainv_ija,sol(pos1:pos2)) + varg_ap*dfvarg)/ &
          (nlev(efanim) + dfvarg)
          varg=chin(varg,dble(nlev(efanim))+dfvarg)
	endif
      endif

      if(efp/=0) then
        if(dfvarp<1000) then
          pos1=add(efp,1)
          pos2=add(efp,nlev(efp))
          varp=(sum(sol(add(efp,1):add(efp,nlev(efp)))**2) + varp_ap*dfvarp)/ &
          (nlev(efp) + dfvarp)
          varp=chin(varp,dble(nlev(efp))+dfvarp)
	endif
      endif

     if(dfvare<1000) then
        vare=(sum(ywiggle**2) + vare_ap*dfvare )/ &
        (ndata + dfvare) 
        vare=chin(vare,dble(ndata)+dfvare)
     endif 
      
      ! sampling proportions
      if(use_mixture) then
	if(efaSNP/=0) then
!          print *,' sampling p from ~Beta',includeda,'+',aprioria(1),'/',nlev(efaSNP)-includeda,'+',aprioria(2)
          pa(1)=random_beta(includeda+aprioria(1),nlev(efaSNP)-includeda+aprioria(2))
          pa(2)=1d0-pa(1)
	endif
	if(efdSNP/=0) then
!          print *,' sampling p from ~Beta',includedd,'+',apriorid(1),'/',nlev(efdSNP)-includedd,'+',apriorid(2)
          pd(1)=random_beta(includedd+apriorid(1),nlev(efdSNP)-includedd+apriorid(2))
          pd(2)=1d0-pd(1)
	endif
      endif
    endif

    
    
    if( (VCE.or.MCMCBLUP) .and. (mod(iter,saving)==0) ) call save_iter()

  enddo inner
  if(GaussSeidel) print *,'eps: ',eps
   
if(VCE)  write(3,*) vara,vard,varg,varp,vare,pa(1),pd(1)
    print *,iter,'ef 1 to 3',sol(1:3),'vara,vard,varg,varp,vare,pa(1),pd(1)', &
	vara,vard,varg,varp,vare,pa(1),pd(1)
!    print *,'variance in y due to a ~~ ',vara*nSNP
  call printtime()

enddo outer

if(.not.GaussSeidel) then 
!  sol=sumsol/(niter-burnin) ! note that this penalizes the mixtured-SNPs
  do i=1,neq
    if(avinmodel(i)>0d0) then 
      sol(i)=sumsol(i)/avinmodel(i)
    else
      sol(i)=0d0
    endif
  enddo
  avinmodel=avinmodel/(niter-burnin)
  sumpa=sumpa/(niter-burnin)
  sumpd=sumpd/(niter-burnin)
endif

call store_solutions()
call compute_EBV()




contains 
		      
function splittoint(genome,nSNP) result(SNP)
! converts one chain of SNP alleles 1211121112 in a matrix of integers
!                                   1 1 1 1 1
!                                   2 1 2 1 2  (transposed)
implicit none
character(len=*) genome
integer:: nSNP,SNP(nSNP,2),aux(nSNP*2)
logical,save:: first=.true.,free=.false.
character(len=20),save:: fmat
! I can put here code to guess if genome has free or condensed format
!does not worj because if this is free format then genome='1       '....
if (first) then !build format
  if( scan(genome(1:(nSNP*2)),' ') > 0) then
    write(*,*) 'blanks found in SNP fields, assuming free format'
    free=.true.
  else 
    write(*,*) 'blanks not found in SNP fields, assuming ''compact'' format: '
    write(fmat,'(i10)')nSNP*2
    fmat=trim('('//adjustl(fmat))//'i1)'
    print *,'format= ',fmat
  endif
  first=.false.
endif

if(free) then
  read(genome,*)aux !does not work
else
  read(genome,fmt=fmat)aux
endif

SNP=reshape(aux,shape(SNP),order=(/2,1/))

end function

  subroutine add_g_add(type)
  ! IMisztal subroutine heavily modified to construct A-1 (without genetic variance!!)
! generates contributions for additive sire or animal effect
  integer :: type,k,l,m,n,io,animal,sire,dam,par_stat,p(3)
  real(r8) ::w(3),res(4),val
!
  select case (type)
     case (3) !animal model
        w=(/1., -.5, -.5/)
        res=(/2., 4/3., 1., 0./)
     case (4) ! sire model
        w=(/1., -.5, -.25/)
        res=(/16/11., 4/3., 16/15., 1./)
  end select

  do
     read(7,*,iostat=io) animal, sire, dam    
     if (io /= 0) exit
     p(1)=animal
     p(2)=sire
     p(3)=dam
     par_stat=1
     if(sire==0) par_stat=par_stat+1
     if(dam==0) par_stat=par_stat+1
     
     do k=1,3
        do l=1,3	
           if (p(k) /= 0 .and. p(l) /=0) then
             m=p(k)
             n=p(l)
	     val=w(k)*w(l)*res(par_stat)
             if(m==n) diagAinv(m)=diagAinv(m)+val
!	     call addm(val,m,n,Ainv_hash,'f') !this stocks the matrix in full !bug? did not work well
	     call addm(val,m,n,Ainv_hash) 
           endif
        enddo
     enddo
  enddo
  Ainv_ija=ainv_hash
call convert_hash_ija_general(ainv_ija,ainv_hash,conv_upper_full)  !convert to full-stored Ainv matrix
!  call convert_hash_ija_full(ainv_ija,ainv_hash) 
  call reset(Ainv_hash)
  
  print *,'n'
  print *,ainv_ija%n
  print *,'nel'
  print *,ainv_ija%nel
  print *,'ia(1:3)'
  print *,ainv_ija%ia(1:3)
  print *,'ja(1st col)'
  !1st col
  print *,ainv_ija%ja(ainv_ija%ia(1):ainv_ija%ia(2)-1)
  
  end subroutine

function update_gs_one_col(whichcol,Ainv_ija,varg,sol,rhs) result(rhsupdated)
!corrects rhs for the whichcol element in sol by the other correlated effects
! this is, one round in one element of GaussSeidel
implicit none
type(sparse_ija) :: Ainv_ija
integer::whichcol,i
real(r8):: rhs,sol(:),rhsupdated,varg

!if(Ainv_ija%n /= size(sol)) then
!  print *,Ainv_ija%n,size(sol),'Ainv_ija%n /= size(sol)'
!  stop
!endif  
!if(whichcol>Ainv_ija%n) then
!  print *,'whichcol>Ainv_ija%n',whichcol,Ainv_ija%n
!  stop
!endif

rhsupdated=rhs
do i=Ainv_ija%ia(whichcol),Ainv_ija%ia(whichcol+1)-1

!  print *,whichcol,i,Ainv_ija%a(i),Ainv_ija%ja(i)

  if(Ainv_ija%ja(i)/=whichcol) &
    rhsupdated=rhsupdated-Ainv_ija%a(i)/varg*sol(Ainv_ija%ja(i))
enddo  

end function

subroutine printtime
INTEGER  DATE_TIME (8)
CHARACTER(LEN = 12) REAL_CLOCK (3)

CALL DATE_AND_TIME (REAL_CLOCK (1), REAL_CLOCK (2), &
                REAL_CLOCK (3), DATE_TIME)

print *,real_clock(1)(7:8),'/',real_clock(1)(5:6),&
'/',real_clock(1)(1:4),' ', &
real_clock(2)(1:2),':',real_clock(2)(3:4),':',real_clock(2)(5:6)

end subroutine

subroutine read_par_file()
implicit none
read(10,*) 
read(10,'(a)') datafile; print*,datafile
read(10,*)
read(10,'(a)') pedfile; print*,pedfile
read(10,*)
read(10,*) nSNP
read(10,*)
read(10,*) method
read(10,*)
read(10,*) simulation
read(10,*) 
read(10,*)
read(10,*) niter
read(10,*)
read(10,*) burnin
read(10,*) 
read(10,*) thin
read(10,*)
read(10,*) conv_crit
read(10,*)
read(10,*) correction
read(10,*)
read(10,'(a)') varfile
read(10,*)
read(10,'(a)') solfile
read(10,*)
read(10,*) traitcol
read(10,*)
read(10,*) neff 
allocate(pos_eff(neff),type_eff(neff),nlev(neff))
read(10,*)

pos_eff=0
type_eff=0
do i=1,neff
  read(10,*)pos_eff(i),type_this_eff,nlev(i)
! guess kind of effects
  do j=1,size(type_eff_char)
    if (type_this_eff==type_eff_char(j)) type_eff(i)=j
    if(type_eff(i)==add_SNP) efaSNP=i
    if(type_eff(i)==dom_SNP) efdSNP=i
    if(type_eff(i)==add_animal) efanim=i
    if(type_eff(i)==perm_diagonal) efp=i
  enddo

enddo  

read(10,*)
read(10,*)
read(10,*) vara,dfvara 
read(10,*)
read(10,*) vard,dfvard
read(10,*)
read(10,*) varg,dfvarg
read(10,*)
read(10,*) varp,dfvarp
read(10,*)
read(10,*) vare,dfvare
read(10,*)
read(10,*) record_id
read(10,*)
read(10,*) continuation
if( (any(type_eff==add_SNP)).or.(any(type_eff==dom_SNP)) ) then
  allocate(in_data(maxval((/pos_eff-1,record_id,traitcol/))))
else  !no SNP effects
  allocate(in_data(maxval( (/pos_eff,record_id,traitcol/))))
endif

vara_ap=vara
vard_ap=vard
varg_ap=varg
varp_ap=varp
vare_ap=vare

allocate(offset(neff),&
	 inmodel(neff))


read(10,*)
read(10,*) inmodel
read(10,*)
read(10,*) aprioria
read(10,*)
read(10,*) apriorid

use_mixture=.false.
read(10,*)
read(10,*) use_mixture

GaussSeidel=.false.; VCE=.false.; MCMCBLUP=.false.;predict=.false.
select case (adjustl(method))
  case('MCMCBLUP')
    MCMCBLUP=.true.
    if(use_mixture) then
      print *,'mixture only compatible with VCE or PREDICT, disabled'
      use_mixture=.false.
    endif
  case('BLUP')
    GaussSeidel=.true.
    if(use_mixture) then
      print *,'mixture only compatible with VCE or PREDICT, disabled'
      use_mixture=.false.
    endif
  case('VCE')
    VCE=.true.
  case('PREDICT')
    predict=.true.
  case default
    print *,'method: ',method,'not available'
    stop
end select
if(GaussSeidel.or.predict) continuation=.false.

if(VCE.or.MCMCBLUP) then
  if (dfvara==-2) then
     vara_ap=0d0
  endif  
  if (dfvard==-2) then
     vard_ap=0d0
  endif  
  if (dfvarg==-2) then
     varg_ap=0d0
  endif  
  if (dfvarp==-2) then
     varp_ap=0d0
  endif  
  if (dfvare==-2) then
     vare_ap=0d0
  endif  
endif

if(sum(abs(aprioria-0d0))<1d-50) then
  pa=0.5d0
else
  pa=dble(aprioria)/sum(aprioria)
endif
if(sum(abs(apriorid-0d0))<1d-50) then
  pd=0.5d0
else
  pd=dble(apriorid)/sum(apriorid)
endif

end subroutine

subroutine print_info()

print *
print *,'----------------------'
print *,'--      GS_cage     --'
print *,'----------------------'
print *,'     by A.Legarra '
!print *                              
!print *,' 42.924959,  -1.818967' 
!print *,'-34.693109, -58.376423'
print *,'----------------------'
call printtime()



print *,'parameter file: ',parfile
print *,'data file: ',datafile
print *,'with: ',ndata,'records'
print *,'reading positions',pos_eff
print *,'the record id is in column',record_id

print *,'pedigree file: ',pedfile
print *,'with: ',nanim,'records read'
print *,'model with',neff,' effects= '
do i=1,neff
  if(inmodel(i)) then
    select case(type_eff(i))
    case (add_SNP) 
      print *,'  -> additive SNP effect in position',pos_eff(i)
    case (dom_SNP)
      print *,'  -> dominant SNP effect in position',pos_eff(i)
    case (ind_SNP)
      print *,'  -> individual SNP effect in position',pos_eff(i)
    case (add_animal)
      print *,'  -> additive infinitesimal effect in position',pos_eff(i)
    case (cross)
      print *,'  -> generic cross-classified ''fixed'' effect in position',pos_eff(i)
    case (cov)
      print *,'  -> generic covariable (not nested) in position',pos_eff(i)
    case (perm_diagonal)
      print *,'  -> generic environmental random effect in position',pos_eff(i)
    case default
      print *,'not supported or incorrectly written',type_eff(i),'for effect',i
      stop
    end select 
    print *,'     with',nlev(i),'levels'
  endif
enddo  
print *,'for a total of',neq,' equations'
print *,'length(in_data)=',size(in_data)

print *,'--------------------------'
if(simulation) print *,'SIMULATED DATA'
if(continuation) then
  print *,'----------------------------------------'
  print *,'Warning: continuation of a previous MCMC'
  print *,'----------------------------------------'
endif
print *,'method: ',method
print *,'variances: vara vard varg varp vare'
print *,vara,vard,varg,varp,vare
print *,'residual is updated (corrected) every',correction,'iterations'
print *,'saving for continuation every',saving,'iterations'
print *
if(GaussSeidel) then
  print *,'--Gauss Seidel parameters--'
  print *,'convergence criterion:',conv_crit
elseif(predict) then
  print *,'--predicting--'
  if(simulation) then
    print *,'predicting simulation   from solutions in ',trim(solfile),  ' to file ''predictions'' '
  else
    print *,'predicting ', trim(datafile),' from solutions in ',trim(solfile),  ' to file ''predictions'' '
  endif
else  
  print *,'--Gibbs sampling parameters--'
  print *,'total number of iterations:',niter
  print *,'discarded for sol estimates:',burnin
  print *,'thin interval:',thin
  print *,'seeds:', s1,s2,s3 !from module ecuyer_random
  if (dfvara==-2) then
    print *,'--> flat prior for vara <--'
  endif  
  if (dfvard==-2) then
    print *,'--> flat prior for vard <--'
  endif  
  if (dfvarg==-2) then
    print *,'--> flat prior for varg <--'
  endif  
  if (dfvarp==-2) then
    print *,'--> flat prior for varp <--'
  endif  
  if (dfvare==-2) then
    print *,'--> flat prior for vare <--'
  endif  
  
  print *,'a priori variances and df'
  print *,' vara ; vard; varg; varp; vare'
  print *,vara_ap,dfvara,';',vard_ap,dfvard,';',varg_ap,dfvarg,';',varp_ap,dfvarp,';',vare_ap,dfvare
  if(use_mixture) then
    print *
    print *,'-----------------------------'
    print *,'Mixture model for SNP effects'
    print *,'-----------------------------'
    print *,'apriori parameters for p(SNP~N(0,vara))'
    print *,aprioria
    if(sum(abs(aprioria-0d0))<1d-50) then
      print *,'--> flat priors for the mixture model <--'
      print *,'initial proportion set to 0.5'
    endif
    print *,'apriori parameters for p(SNP~N(0,vard))'
    print *,apriorid
    if(sum(abs(apriorid-0d0))<1d-50) then
      print *,'--> flat priors for the mixture model <--'
      print *,'initial proportion set to 0.5'
    endif
  endif

endif    
print *,'--------------------'
print *

end subroutine

  subroutine store_solutions
  !from blupf90
  ! store solutions in file 'solutions'
  integer e,l
  open(11,file=solfile,status='replace')
  write(11,'(''effect level  solution zscore'')')
  do e=1,neff
    do l=1,nlev(e)
       write(11,'(i3,i8,2f16.8)')e,l, sol(offset(e)+l),avinmodel(offset(e)+l)
    enddo
  enddo
  close(11)
  print*,'solutions stored in file: ',solfile
  end subroutine
  
subroutine restart_iter()
! read from continuation file
implicit none
integer:: i,j
open(13,file=trim(parfile)//'_cont',status='old')
read(13,*) iter
read(13,*) s1,s2,s3
read(13,*) vara
read(13,*) vard
read(13,*) varg
read(13,*) varp
read(13,*) vare
read(13,*) pa
read(13,*) pd
read(13,*) sumpa
read(13,*) sumpd
read(13,*)
do i=1,neq
  read(13,*) j,sol(i),sumsol(i),avinmodel(i)
  if(j/=i) then
    print *,'error reading continuation',i,j
    stop
  endif
enddo
print *,'restart from iteration',iter
close(13)
end subroutine  

subroutine save_iter()
! save iterations
implicit none
integer:: i
open(13,file=trim(parfile)//'_cont',status='replace')
write(13,*) iter, 'iteration'
write(13,*) s1,s2,s3, 'seeds'
write(13,*) vara,'vara'
write(13,*) vard,'vard'
write(13,*) varg,'varg'
write(13,*) varp,'varp'
write(13,*) vare,'vare'
write(13,*) pa,'pa'
write(13,*) pd,'pd'
write(13,*) sumpa,'sumpa'
write(13,*) sumpd,'sumpd'
write(13,*) 'sol, sumsol, zscore'
do i=1,neq
  write(13,*) i,sol(i),sumsol(i),avinmodel(i)
enddo
close(13)
end subroutine  


subroutine setup_inmodel()
! for the aux variable i_inmodel fills in whether level i 
! of the equations is in model or not
implicit none
integer:: i,pos1,pos2
do i=1,neff
  pos1=add(i,1)
  pos2=add(i,nlev(i))
  i_inmodel(pos1:pos2)=inmodel(i)
enddo
end subroutine


function add(effect,level)
! address of level in effect
implicit none
integer:: effect,level,add
  add=offset(effect)+level
end function


subroutine simulate()
!  call get_clock_seeds()
  sol(1)=0d0
  sol(2)=0d0
  sol(3)=0d0
  pos1=add(efaSNP,1); pos2=add(efaSNP,nlev(efaSNP))
  kk: do i=pos1,pos2
    if( importance((/.true.,.false./),(/.002d0,.998d0/)) ) then
      sol(i)=normal(0d0,vara)
      includeda=includeda+1
      print *,'includeda',includeda,i
      exit kk
    endif
  enddo kk
  print *,'vara',sum(sol(pos1:pos2)**2)/includeda

  do i=1,ndata
    y(i)=normal(0d0,vare)
  enddo
  print *,'vare',sum(y**2)/ndata
!  y=y+matmul(X,sol)
  print *,'vary',sum((y-sol(1))**2)/ndata
  sol=0d0
  
end subroutine

subroutine add_X(cov,rec,eq,pos)
implicit none
real(r8)::cov
integer:: rec,eq,pos
! fills in X matrix
if(pos>maxrec) then
  print *,'X too small, increasing'
  call increase_X()
endif
X%cov(pos)=cov  
X%rec(pos)=rec  
X%eq(pos)=eq  
end subroutine

subroutine increase_X(ideal)
! increase X design matrix structure by 50%
! AL 2/8/07
implicit none
type(design_matrix):: X_temp
integer:: newmaxrec,oldmaxrec
integer,optional:: ideal

! create temp storage
oldmaxrec=maxrec
allocate(X_temp%cov(oldmaxrec),&
         X_temp%rec(oldmaxrec),&
         X_temp%eq(oldmaxrec))

X_temp%cov=X%cov
X_temp%rec=X%rec
X_temp%eq=X%eq

if(present(ideal)) then 
  newmaxrec=ideal
else  
  newmaxrec=floor(1.5*oldmaxrec) !new size
endif  
print *,'changing size of X from: ', oldmaxrec, 'to: ',newmaxrec

deallocate(X%cov,&
         X%rec,&
         X%eq)

allocate(X%cov(newmaxrec),&
         X%rec(newmaxrec),&
         X%eq(newmaxrec) )
X%cov=0d0; X%rec=0; X%eq=0	 

if(newmaxrec<oldmaxrec) then
  X%cov=X_temp%cov(1:newmaxrec)
  X%rec=X_temp%rec(1:newmaxrec)
  X%eq=X_temp%eq(1:newmaxrec)
else
  print *,'changing size of X from: ', oldmaxrec, 'to: ',newmaxrec
  X%cov(1:oldmaxrec)=X_temp%cov
  X%rec(1:oldmaxrec)=X_temp%rec
  X%eq(1:oldmaxrec)=X_temp%eq
endif

deallocate(X_temp%cov,&
         X_temp%rec,&
         X_temp%eq)
maxrec=newmaxrec
print *,'lengths in increase_X: ',size(X%rec),size(X%cov),size(X%eq)


end subroutine

subroutine sort_X()
! sort X so that neq is ordered in increasing order; this *should* increase speed
! first send key to be sorted
implicit none
integer:: key(maxrec),i
type(design_matrix):: temp

allocate(temp%cov(maxrec),temp%eq(maxrec),temp%rec(maxrec))
! get index
call qsortd(X%eq,key,maxrec)

do i=1,maxrec
  temp%cov(i)=X%cov(key(i))
  temp%eq(i)=X%eq(key(i))
  temp%rec(i)=X%rec(key(i))
enddo  
X%cov=temp%cov
X%rec=temp%rec
X%eq=temp%eq
  
deallocate(temp%cov,temp%eq,temp%rec)
end subroutine  

subroutine index_X()
! now index X%ia_eq(i,:) contains the row of X having the 1st & last appearance of equation i
! Note that there might be some 'holes' (for SNP effects or animals)
! Changed to return the first and *last* element
implicit none
integer:: i,oldeq

X%ia_eq(1,1)=1
oldeq=1

do i=2,maxrec
  if(X%eq(i)/=oldeq)then
    X%ia_eq(oldeq,2)=i-1 !level of eq before
    X%ia_eq(X%eq(i),1)=i !level of the eq
    oldeq=X%eq(i)
  endif  
enddo
X%ia_eq(oldeq,2)=maxrec
end subroutine  

! I need to note how this works for a simple example...





subroutine compute_residuals()
!compute residuals ywiggle from y and X, W, Z
! e=ywiggle=y-[X W Z] [b u a d]
implicit none
integer::i
ywiggle=y
! traverse X
do i=1,maxrec
  ywiggle(X%rec(i))=ywiggle(X%rec(i))-sol(X%eq(i))*X%cov(i)
enddo
! addSNP
if(efaSNP/=0) then
  pos1=add(efaSNP,1)
  pos2=add(efaSNP,nlev(efaSNP))
  ywiggle=ywiggle-matmul(Z,sol(pos1:pos2))
endif
! domSNP
if(efdSNP/=0) then
  pos1=add(efdSNP,1)
  pos2=add(efdSNP,nlev(efdSNP))
  ywiggle=ywiggle-matmul(W,sol(pos1:pos2))
endif
end subroutine

subroutine predict_y(nofixedeffects,whichone)
!predict y from sol and X, W, Z
! y^=[X W Z] [b u a d]
! this is stored in ywiggle
! also correct y for fixed effects if nofixedeffects=.true. (this
! simplifies interpretation of the results)
implicit none
logical,optional:: nofixedeffects
integer,optional:: whichone
logical:: usefe
real(r8)::avinmodel_updated(neq) ! this one is updated with 0 
                            ! for nullified effects or average z-score for mixture terms
! think in modifying for outputting genetic predictions!!
! perhaps through the matrix inmodel??


usefe=.true.
if(present(nofixedeffects))then
  if(nofixedeffects) usefe=.false.
endif  

avinmodel_updated=avinmodel ! note that this is 1 for BLUP
  ! so we do not need to deal with mixture or not, that comes from
  ! the solutions file

if(.not.usefe) then
  ! nullify fixed effects in avinmodel
  do i=1,neff
    if((type_eff(i)==cov).or.(type_eff(i)==cross)) then ! if f.e.
      avinmodel_updated(add(i,1):add(i,nlev(i)))=0d0
      ! this implies: I corret y for fixed effects in order to get a proper correlation, and
      !               I do not add fixed effects to the estimation of y in ^y
    endif
  enddo
endif 

! need to do it here otherwise is a mess
do i=1,maxrec
  y(X%rec(i))=y(X%rec(i))-sol(X%eq(i))*X%cov(i)*abs(1d0-avinmodel_updated(X%eq(i)))
enddo

if(present(whichone))then
! this is to nullify appropriate terms when computing genomic EBV's
  do i=1,neff
    pos1=add(i,1)
    pos2=add(i,nlev(i))
    if(i/=whichone)then
      avinmodel_updated(pos1:pos2)=0d0
    endif
  enddo
endif


! this was a simpler way but not feasible for mixture or nullify fixed effects
! call compute_residuals()
! y^=y-e
! ywiggle=y-ywiggle
! the following code is similar to compute_residuals 
ywiggle=0d0
! traverse X
do i=1,maxrec
  ywiggle(X%rec(i))=ywiggle(X%rec(i))+sol(X%eq(i))*X%cov(i)*avinmodel_updated(X%eq(i))
  ! not sure whether doing this with mixture effects is correct
enddo
! addSNP
if(efaSNP/=0) then
  pos1=add(efaSNP,1)
  pos2=add(efaSNP,nlev(efaSNP))
  ywiggle=ywiggle+matmul(Z,sol(pos1:pos2))*avinmodel_updated(i)
endif
! domSNP
if(efdSNP/=0) then
  pos1=add(efdSNP,1)
  pos2=add(efdSNP,nlev(efdSNP))
  ywiggle=ywiggle+matmul(W,sol(pos1:pos2))*avinmodel_updated(i)
endif
!NOTE THAT Y IS MODIFIED AFTER LEAVING THE SUBROUTINE!!
end subroutine


subroutine compute_ebv()
! this subroutine outputs ebv's for animals in data *only*
real(r8):: ebv_asnp(size(ywiggle))
real(r8):: ebv_dsnp(size(ywiggle))
real(r8):: ebv_anim(size(ywiggle))
!real(r8):: pheno(size(y))

!  pheno=y
  call predict_y(nofixedeffects=.true.,whichone=efaSNP)
  ebv_asnp=ywiggle
  !!! THIS IS WRONG
  call predict_y(nofixedeffects=.true.,whichone=efdSNP)
  ebv_dsnp=ywiggle
  call predict_y(nofixedeffects=.true.,whichone=efanim)
  ebv_anim=ywiggle
  write(14,*) 'id EBV_aSNP EBV_dSNP EBV_anim'
  do i=1,ndata
!    write(14,*)id(i),pheno(i),ebv_asnp(i),ebv_dsnp(i),ebv_anim(i)
    write(14,*)id(i),ebv_asnp(i),ebv_dsnp(i),ebv_anim(i)
  enddo  
  print *,'EBV''s written'
  
end subroutine



SUBROUTINE qsortd(x,ind,n)
 
! Code converted using TO_F90 by Alan Miller
! Date: 2002-12-18  Time: 11:55:47

IMPLICIT NONE
INTEGER, PARAMETER  :: dp = SELECTED_REAL_KIND(12, 60)

!REAL (dp), INTENT(IN)  :: x(:)
integer, INTENT(IN)  :: x(:)
INTEGER, INTENT(OUT)   :: ind(:)
INTEGER, INTENT(IN)    :: n

!***************************************************************************

!                                                         ROBERT RENKA
!                                                 OAK RIDGE NATL. LAB.

!   THIS SUBROUTINE USES AN ORDER N*LOG(N) QUICK SORT TO SORT A REAL (dp)
! ARRAY X INTO INCREASING ORDER.  THE ALGORITHM IS AS FOLLOWS.  IND IS
! INITIALIZED TO THE ORDERED SEQUENCE OF INDICES 1,...,N, AND ALL INTERCHANGES
! ARE APPLIED TO IND.  X IS DIVIDED INTO TWO PORTIONS BY PICKING A CENTRAL
! ELEMENT T.  THE FIRST AND LAST ELEMENTS ARE COMPARED WITH T, AND
! INTERCHANGES ARE APPLIED AS NECESSARY SO THAT THE THREE VALUES ARE IN
! ASCENDING ORDER.  INTERCHANGES ARE THEN APPLIED SO THAT ALL ELEMENTS
! GREATER THAN T ARE IN THE UPPER PORTION OF THE ARRAY AND ALL ELEMENTS
! LESS THAN T ARE IN THE LOWER PORTION.  THE UPPER AND LOWER INDICES OF ONE
! OF THE PORTIONS ARE SAVED IN LOCAL ARRAYS, AND THE PROCESS IS REPEATED
! ITERATIVELY ON THE OTHER PORTION.  WHEN A PORTION IS COMPLETELY SORTED,
! THE PROCESS BEGINS AGAIN BY RETRIEVING THE INDICES BOUNDING ANOTHER
! UNSORTED PORTION.

! INPUT PARAMETERS -   N - LENGTH OF THE ARRAY X.

!                      X - VECTOR OF LENGTH N TO BE SORTED.

!                    IND - VECTOR OF LENGTH >= N.

! N AND X ARE NOT ALTERED BY THIS ROUTINE.

! OUTPUT PARAMETER - IND - SEQUENCE OF INDICES 1,...,N PERMUTED IN THE SAME
!                          FASHION AS X WOULD BE.  THUS, THE ORDERING ON
!                          X IS DEFINED BY Y(I) = X(IND(I)).

!*********************************************************************

! NOTE -- IU AND IL MUST BE DIMENSIONED >= LOG(N) WHERE LOG HAS BASE 2.

!*********************************************************************

INTEGER   :: iu(21), il(21)
INTEGER   :: m, i, j, k, l, ij, it, itt, indx
REAL      :: r
!REAL (dp) :: t
integer :: t

! LOCAL PARAMETERS -

! IU,IL =  TEMPORARY STORAGE FOR THE UPPER AND LOWER
!            INDICES OF PORTIONS OF THE ARRAY X
! M =      INDEX FOR IU AND IL
! I,J =    LOWER AND UPPER INDICES OF A PORTION OF X
! K,L =    INDICES IN THE RANGE I,...,J
! IJ =     RANDOMLY CHOSEN INDEX BETWEEN I AND J
! IT,ITT = TEMPORARY STORAGE FOR INTERCHANGES IN IND
! INDX =   TEMPORARY INDEX FOR X
! R =      PSEUDO RANDOM NUMBER FOR GENERATING IJ
! T =      CENTRAL ELEMENT OF X

IF (n <= 0) RETURN

! INITIALIZE IND, M, I, J, AND R

DO  i = 1, n
  ind(i) = i
END DO
m = 1
i = 1
j = n
r = .375

! TOP OF LOOP

20 IF (i >= j) GO TO 70
IF (r <= .5898437) THEN
  r = r + .0390625
ELSE
  r = r - .21875
END IF

! INITIALIZE K

30 k = i

! SELECT A CENTRAL ELEMENT OF X AND SAVE IT IN T

ij = i + r*(j-i)
it = ind(ij)
t = x(it)

! IF THE FIRST ELEMENT OF THE ARRAY IS GREATER THAN T,
!   INTERCHANGE IT WITH T

indx = ind(i)
IF (x(indx) > t) THEN
  ind(ij) = indx
  ind(i) = it
  it = indx
  t = x(it)
END IF

! INITIALIZE L

l = j

! IF THE LAST ELEMENT OF THE ARRAY IS LESS THAN T,
!   INTERCHANGE IT WITH T

indx = ind(j)
IF (x(indx) >= t) GO TO 50
ind(ij) = indx
ind(j) = it
it = indx
t = x(it)

! IF THE FIRST ELEMENT OF THE ARRAY IS GREATER THAN T,
!   INTERCHANGE IT WITH T

indx = ind(i)
IF (x(indx) <= t) GO TO 50
ind(ij) = indx
ind(i) = it
it = indx
t = x(it)
GO TO 50

! INTERCHANGE ELEMENTS K AND L

40 itt = ind(l)
ind(l) = ind(k)
ind(k) = itt

! FIND AN ELEMENT IN THE UPPER PART OF THE ARRAY WHICH IS
!   NOT LARGER THAN T

50 l = l - 1
indx = ind(l)
IF (x(indx) > t) GO TO 50

! FIND AN ELEMENT IN THE LOWER PART OF THE ARRAY WHCIH IS NOT SMALLER THAN T

60 k = k + 1
indx = ind(k)
IF (x(indx) < t) GO TO 60

! IF K <= L, INTERCHANGE ELEMENTS K AND L

IF (k <= l) GO TO 40

! SAVE THE UPPER AND LOWER SUBSCRIPTS OF THE PORTION OF THE
!   ARRAY YET TO BE SORTED

IF (l-i > j-k) THEN
  il(m) = i
  iu(m) = l
  i = k
  m = m + 1
  GO TO 80
END IF

il(m) = k
iu(m) = j
j = l
m = m + 1
GO TO 80

! BEGIN AGAIN ON ANOTHER UNSORTED PORTION OF THE ARRAY

70 m = m - 1
IF (m == 0) RETURN
i = il(m)
j = iu(m)

80 IF (j-i >= 11) GO TO 30
IF (i == 1) GO TO 20
i = i - 1

! SORT ELEMENTS I+1,...,J.  NOTE THAT 1 <= I < J AND J-I < 11.

90 i = i + 1
IF (i == j) GO TO 70
indx = ind(i+1)
t = x(indx)
it = indx
indx = ind(i)
IF (x(indx) <= t) GO TO 90
k = i

100 ind(k+1) = ind(k)
k = k - 1
indx = ind(k)
IF (t < x(indx)) GO TO 100

ind(k+1) = it
GO TO 90
END SUBROUTINE qsortd



end		    



